////////////////////////////////////////////////////////////
// binwr.c - Binary File Writing Utility
////////////////////////////////////////////////////////////

#include <stdio.h>
#include <strings.h>

char outputName[80];
char inputName[80];
char byteSize=1;

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
void showUsage(void);
int writeFromFile(void);
int writeFromKeys(void);

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
int main(int argc, char *argv[]) {
int i, err = 0;

   for (i = 1; i < argc; i++) {
       if (argv[i][0] == '.') {
          strcpy(outputName, &argv[i][1]);
       } else if (argv[i][0] == ',') {
         strcpy(inputName, &argv[i][1]);
       } else if (!stricmp(argv[i], "/if")) {
         printf("Read from what file?\n");
         scanf("%s", inputName);
       } else if (strstr(argv[i], "/s") || strstr(argv[i], "/S")) {
         byteSize = atoi(&argv[i][2]);
       } else if (!stricmp(argv[i], "-usage") || !stricmp(argv[i], "-help") ||
           !stricmp(argv[i], "-?")) {
              showUsage();
       }
   } // for i < argc

   if (argc <= 1) {
      showUsage();
      printf("\n");
      delay(250);
   }

   if (!strlen(outputName)) {
      printf("Write to what file?\n");
      scanf("%s", outputName);
   }

   if (strlen(inputName)) {
      err = writeFromFile();
   } else err = writeFromKeys();


// end main
return err;
}

////////////////////////////////////////////////////////////
void showUsage(void) {

   printf("binwr.exe [.<file>][,<file>][/if][/s<number>]\[-usage][-?][-help]n");
   printf("          \".<file>\" sets the output filename. There should be no space after\n");
   printf("                    the redirect symbol ('>')\n");
   printf("          \",<file>\" sets the input filename. There should be no space after\n");
   printf("                    the redirect symbol ('<')\n");
   printf("          \"/if\" prompts (shabbily) for an input file\n");
   printf("          \"/s<number>\" sets the size of the numbers to be written (in bytes)\n");
   printf("                       The default is 1 byte (char). Short int is 2. Int is 4.\n");
   printf("                       There should be no space between the s and the number\n");
   printf("          \"-usage\" & \"-?\" & \"-help\" all show this screen.\n");
   printf("   If you specify no output file, it will ask for one. If you specify no input\n");
   printf("   file, it will take input from the keyboard.\n\n");
   printf("BinWrite is copyright Joe Kopena 1999. Contact him at scarius@geocities.com\n");

// end showUsage
}

////////////////////////////////////////////////////////////
int writeFromFile(void) {
FILE *fp;
FILE *output;
char st[32];
int oi;
short os;
char oc;

   if (!(fp = fopen(inputName, "rt"))) {
      fprintf(stderr, "Could not load \"%s\" for input!\n", inputName);
      return -1;
   } // fopen()

   if (!(output = fopen(outputName, "wb"))) {
      fprintf(stderr, "Could not open \"%s\" for writing!\n", outputName);
      return -1;
   }

   while (!feof(fp)) {
          fscanf(fp, "%s", st);
          if (!feof(fp)) // If you just read the end of the file, ignore it
             switch (byteSize) {
                 case 1:
                      oc = atoi(st);
                      fwrite(&oc, 1, 1, output);
                 break;
                 case 2:
                      os = atoi(st);
                      fwrite(&os, 2, 1, output);
                 break;
                 case 4:
                      oi = atoi(st);
                      fwrite(&oi, 4, 1, output);
                 break;
             } // end switch
   } // while !feof(fp);

   fclose(output);
   fclose(fp);

// emd writeFromFile
return 0;
}

////////////////////////////////////////////////////////////
int writeFromKeys(void) {
int done = 0;
FILE *output;
char st[32];
int oi;
short os;
char oc;

   if (!(output = fopen(outputName, "wb"))) {
      fprintf(stderr, "Could not open \"%s\" for writing!\n", outputName);
      return -1;
   }

   printf("Enter your numbers. Type in \"end\" to stop.\n");
   while (!done) {
         scanf("%s", st);
         if (!stricmp(st, "end")) {
            done = 1;
         } else {
           switch (byteSize) {
                  case 1:
                       oc = atoi(st);
                       fwrite(&oc, 1, 1, output);
                  break;
                  case 2:
                       os = atoi(st);
                       fwrite(&os, 2, 1, output);
                  break;
                  case 4:
                       oi = atoi(st);
                       fwrite(&oi, 4, 1, output);
                  break;
           } // end switch
         } // Was not "end" - must be number :)
   } // while !done

   fclose(output);

// end writeFromKeys
return 0;
}

